<?php
// -------------------------------------------------------------------------
// Récupère les informations relatives aux adhérents dans la base de données
// et renvoie un fichier XML qui sera lu par le code API Google Map.
// -------------------------------------------------------------------------

// Fonction de mise en forme de texte pour le xml
function parseToXML($htmlStr) 
{ 
$xmlStr=str_replace('<','&lt;',$htmlStr); 
$xmlStr=str_replace('>','&gt;',$xmlStr); 
$xmlStr=str_replace('"','&quot;',$xmlStr); 
$xmlStr=str_replace("'",'&#39;',$xmlStr); 
$xmlStr=str_replace("&",'&amp;',$xmlStr); 
return $xmlStr; 
}

// Fonction vérifiant si plusieurs points ont exactement les mêmes coordonnées
// Si un point du tableau $coord a déjà les coordonnées $lat $lon,
// on décale modifie très légèrement les coordonnées du point testé.
// On relance ensuite la fonction pour vérifier qu'autre point n'a pas les mêmes
// coordonées que celles qu'on vient de modifier.
// Et ainsi de site jusqu'à qu'on trouve des coordonnées qui ne correspondent pas déjà à un point.
// On évite ainsi d'avoir des points superposés sur la carte
//(en attendant de trouver une façon plus propre de séparer les points superposés ...)
function verif_coord($lat, $lon, $coord){
	if(in_array(array($lat, $lon),$coord)){
		$lat = $lat + 0.00001;
		$lon = $lon - 0.00001;
		$result = verif_coord($lat, $lon, $coord) ;
		$lat = $result[0];
		$lon = $result[1];
	}
	return array($lat, $lon);
}

// Récupération des informations de connexion à la base de données (fichier de configuration de Galette)
include('../galette/includes/config.inc.php');

// Connexion à la base de données
$connect = mysql_connect(HOST_DB, USER_DB, PWD_DB);
if(!$connect){
	die('Connexion à la base de données impossible : '.mysql_error());
}

//Sélection de la base de données
$db = mysql_select_db(NAME_DB, $connect);
if(!$db){
	die('Sélection de la base de données impossible : '.mysql_error());
}

//Sélection des infos dans la table galette_adherents,
//seulement pour les adhérents actuels (activite_adh=1) et qui souhaitent afficher leurs infos (bool_display_info=1)
$query = "SELECT 
		  A.id_adh AS id, 
		  A.nom_adh AS nom,
		  A.titre_adh AS titre, 
		  A.prenom_adh AS prenom, 
		  A.adresse_adh AS adresse1,
		  A.adresse2_adh AS adresse2, 
		  A.cp_adh AS CP, 
		  A.ville_adh AS ville, 
		  A.pays_adh AS pays,
		  A.tel_adh AS tel1, 
		  A.gsm_adh AS tel2, 
		  A.email_adh AS email, 
		  A.url_adh AS url, 
		  A.info_public_adh AS info, 
		  P.id_adh AS photo
		  FROM galette_adherents A
			   LEFT OUTER JOIN galette_pictures P
			   		ON A.id_adh = P.id_adh
		  WHERE A.activite_adh = '1' 
		  AND A.bool_display_info = '1'";
$result = mysql_query($query);
if(!$result){
	die("L'exécution de la requête a retourné une erreur : ".mysql_error());
}

// Début du fichier xml
header("Content-type: text/xml");

echo '<markers>';

// Initialisation du tableau dans lequel on va stocker les coordonnées pour vérifier que deux points n'ont pas les mêmes coordonnées
$coord = array();
$i = 1;

// Pour chaque enregistrement retourné par la requête ...
while($row = @mysql_fetch_assoc($result)){
	
	//On va chercher les latitude et longitude de l'adhérents dans la table galette_dynamic_fields
	// Latitude
	$querylat = "SELECT field_val 
			  FROM galette_dynamic_fields 
			  WHERE item_id='".$row['id']."' 
			  AND field_id = '4'";
	$resultlat = mysql_query($querylat);
	if(!$resultlat){
		die("L'exécution de la requête a retourné une erreur : ".mysql_error());
	}
	$rowlat = mysql_fetch_array($resultlat);
	$lat = $rowlat[0];
	// Longitude
	$querylon = "SELECT field_val 
			  FROM galette_dynamic_fields 
			  WHERE item_id='".$row['id']."' 
			  AND field_id = '5'";
	$resultlon = mysql_query($querylon);
	if(!$resultlon){
		die("L'exécution de la requête a retourné une erreur : ".mysql_error());
	}
	$rowlon = mysql_fetch_array($resultlon);
	$lng = $rowlon[0];
	
	// On vérifie qu'un autre point déjà traité n'a pas les mêmes coordonnées
	$latlon = verif_coord($lat,$lng, $coord);
	$lat = $latlon[0];
	$lng = $latlon[1];
	$coord[$i] = array($lat, $lng);
	$i++;
	
	// puis on crée un élément avec les attributs associés
	echo '<marker ';
	echo 'nom="' . parseToXML(mb_strtoupper($row['nom'],'UTF-8')) . '" ';
	echo 'prenom="' . parseToXML($row['prenom']) . '" ';
	echo 'titre="' . parseToXML($row['titre']) . '" ';
  	echo 'adresse1="' . parseToXML($row['adresse1']) . '" ';
	echo 'adresse2="' . parseToXML($row['adresse2']) . '" ';
	echo 'CP="' . parseToXML($row['CP']) . '" ';
	echo 'ville="' . parseToXML(mb_strtoupper($row['ville'],'UTF-8')) . '" ';
	echo 'pays="' . parseToXML(mb_strtoupper($row['pays'],'UTF-8')) . '" ';
	echo 'tel1="' . parseToXML($row['tel1']) . '" ';
	echo 'tel2="' . parseToXML($row['tel2']) . '" ';
	echo 'email="' . parseToXML($row['email']) . '" ';
	echo 'url="' . parseToXML($row['url']) . '" ';
	echo 'info="' . parseToXML($row['info']) . '" ';
	echo 'photo="' . $row['photo'] . '" ';
	echo 'lat="' .  $lat . '" ';
	echo 'lng="' .  $lng . '" ';
	echo '/>';

}

// Fin du fichier xml
echo '</markers>';


// Fermeture de la connexion à la base de données
mysql_close($connect);

?>